% Copyright 2004 by Till Tantau <tantau@users.sourceforge.net>.
%
% In principle, this file can be redistributed and/or modified under
% the terms of the GNU Public License, version 2.
%
% However, this file is supposed to be a template to be modified
% for your own needs. For this reason, if you use this file as a
% template and not specifically distribute it as part of a another
% package/program, I grant the extra permission to freely copy and
% modify this file as you see fit and even to delete this copyright
% notice. 

\documentclass{beamer}


\usepackage{array}


% There are many different themes available for Beamer. A comprehensive
% list with examples is given here:
% http://deic.uab.es/~iblanes/beamer_gallery/index_by_theme.html
% You can uncomment the themes below if you would like to use a different
% one:
%\usetheme{AnnArbor}
%\usetheme{Antibes}
%\usetheme{Bergen}
%\usetheme{Berkeley}
%\usetheme{Berlin}
%\usetheme{Boadilla}
%\usetheme{boxes}
%\usetheme{CambridgeUS}
%\usetheme{Copenhagen}
%\usetheme{Darmstadt}
%\usetheme{default}
%\usetheme{Frankfurt}
%\usetheme{Goettingen}
%\usetheme{Hannover}
%\usetheme{Ilmenau}
%\usetheme{JuanLesPins}
%\usetheme{Luebeck}
\usetheme{Madrid}
%\usetheme{Malmoe}
%\usetheme{Marburg}
%\usetheme{Montpellier}
%\usetheme{PaloAlto}
%\usetheme{Pittsburgh}
%\usetheme{Rochester}
%\usetheme{Singapore}
%\usetheme{Szeged}
%\usetheme{Warsaw}

\setbeamertemplate{footline}[frame number]{}
\setbeamertemplate{navigation symbols}{}


\title{A Network-centric TCP for Interactive Video Delivery Networks (VDN)}


\author{MD Iftakharul Islam, Javed I Khan}
% - Give the names in the same order as the appear in the paper.
% - Use the \inst{?} command only if the authors have different
%   affiliation.

\institute[Kent State University] % (optional, but mostly needed)
{
  Department of Computer Science\\
  Kent State University\\
  Kent, OH
}

 \date[\today]{}
 
% - Use the \inst command only if there are several affiliations.
% - Keep it simple, no one is interested in your street address.

% This is only inserted into the PDF information catalog. Can be left
% out. 

% If you have a file called "university-logo-filename.xxx", where xxx
% is a graphic format that can be processed by latex or pdflatex,
% resp., then you can add a logo as follows:

% \pgfdeclareimage[height=0.5cm]{university-logo}{university-logo-filename}
% \logo{\pgfuseimage{university-logo}}

% Delete this, if you do not want the table of contents to pop up at
% the beginning of each subsection:


% Let's get started
\begin{document}

\begin{frame}
  \titlepage
\end{frame}

\begin{frame}{Outline}
  \tableofcontents
  % You might wish to add the option [pausesections]
\end{frame}

% Section and subsections will appear in the presentation overview
% and table of contents.
\section{Interactive Video Delivery Network (VDN)}

\begin{frame}{Congestion Control for Video Streaming}
	\begin{itemize}
		\item {
			Interactive video streaming such as Skype and Google Hangout use delay based congestion control.			
		}
			
		\item {
			The delay-based congestion control however does not have accurate congestion information which results in:
			\begin{itemize}
				\item  High queuing delay in the router 
				\item  Poor fairness which results in poor QoE				
			\end{itemize}			
		}
		\item {
			Network centric TCP such as XCP, RCP and so on solve this problem by providing explicit feedback from router 
				\begin{figure}[!t]
					\centering
					\includegraphics[width=5cm]{workflow}
					\caption{Work flow of NC-TCP}\label{workflow}
				\end{figure}
		}
		
	\end{itemize}
\end{frame}

\begin{frame}{Interactive Video Delivery Network (VDN)}
  \begin{itemize}
  \item {
XCP and RCP is however designed as TCP-friendly 
as they assumed the delay sensitive traffic can compete will loss sensitive traffic.
  }
  \item {
Loss-based TCP flows results long queuing delay on the router (\alert{Bufferebloat problem})
  }
  
 \item {
Solution:
    \begin{itemize}
  \item {
  	Differentiated service and network slicing enable us to create exclusive video network where interactive video flows competes among themselves.
  }
    \end{itemize}
 }

\item{
	We have designed a TCP for Interactive Video Network. We have shown that our newly designed TCP (NC-TCP) can perform better than XCP and delay based TCP in Video Delivery Network.
	}

  \end{itemize}
\end{frame}

\section{Why TCP?}

% You can reveal the parts of a slide one at a time
% with the \pause command:
\begin{frame}{Why TCP?}
  \begin{itemize}
  \item {
Video Streaming traditionally uses UDP. But UDP has many disadvantages:
  }
    \begin{itemize}
  \item {   
	It does not have any congestion control.
  }
  % You can also specify when the content should appear
  % by using <n->:
  \item {
    Application developers needs to implement their own congestion control.
  }
  \item {
    Different implementation of congestion control interacts poorly with each other and stability of the network is compromised.
  }
  % or you can use the \uncover command to reveal general
  % content (not just \items):
  \item {
    UDP is also not NAT and firewall friendly which are highly desirable attributes in today's Internet 
  }
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}{Why TCP?}
	\begin{itemize}
		\item {
			TCP solves these problems, however TCP has some problems regarding interactive video streaming:
		}
		\begin{itemize}
			\item {   
				The ordered delivery of TCP delays some segment delivery if a prior segment is missing (\alert{head-of-line blocking problem} ).
			}
			% You can also specify when the content should appear
			% by using <n->:
			\item {
				Retransmission is also not required in interactive video streaming
			}
			\item {
				These problems can be solved by implementing different TCP implementation. For example:
			}
			\begin{itemize}
			% or you can use the \uncover command to reveal general
			% content (not just \items):
			\item {
				TCP Hollywood allows unordered segment delivery. 
			}				
			\item {
Retransmission can be avoided by extensive packet caching in the router.
			}			
			\end{itemize}
		\end{itemize}
	\end{itemize}
\end{frame}

\section{Delay-based TCP}
\begin{frame}{Delay-based TCP}
	\begin{itemize}
		\item {
Video streaming traditionally uses delay based congestion control.
		}
		\item {
It modifies the congestion window based on RTT.
		}
			\begin{itemize}
				\item {
				TCP Vegas, TCP FAST
				}
			\end{itemize}		
		\item {
RTT based TCP loses throughput in the presence of reverse-path congestion.

		}
		
		\item{
To solve this problem, LEDBAT uses one-way delay based congestion control.
		}
		
		\item LEDBAT however suffers latecomer effect: second flow may starve first flow.
		
		\item One-way delay gradient has been used to overcome the late comers effect. 		
					\begin{itemize}
						\item TCP CDG, TCP Inigo
						\item Google Hangout (doesn’t use TCP though)						
					\end{itemize}	
	\end{itemize}
\end{frame}

\begin{frame}{Delay-based TCP}
	\begin{itemize}
		\item Delay-based TCP controls the congestion window based on one-way delay observed in the receiver.
		\item It has no way of knowing about the actual queuing delay in the network. This is why, it faces several problems:
		\begin{itemize}
			\item It cannot result near-zero queuing delay in the network.
			\item It performs poorly in fairness. This is why some flows experience poor throughput which results poor video quality in video streaming.
		\end{itemize}
		\item Recent advances in \alert{Software Defined Networks (SDN)} can solve this problem
	\end{itemize}
\end{frame}
		
\section{Network-centric TCP}
\begin{frame}{Network-centric TCP}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{workflow}
		\caption{Work flow of NC-TCP}\label{workflow}
	\end{figure}
\end{frame}
\begin{frame}{Network-centric TCP}
	\begin{itemize}
		\item Routers play an active role in allocating throughput.
		\item NC-TCP uses rate-based congestion control rather than window based congestion control.
		\begin{itemize}
			\item Window-based TCP produces bursty traffic. Rate-based congestion control shape the traffic before sending
			\item It also ensures that the network does not have more traffic than it is able to handle.
			\item We used \textbf{TCP-pacing}
		\end{itemize}
		\item NC-TCP has been implemented as a new TCP option.
\begin{figure}[!t]
	\centering
	\includegraphics[width=3cm]{im-option}
	\caption{NC option}\label{im-option}
\end{figure}		
	\end{itemize}
\end{frame}
\begin{frame}{NC-TCP Workflow}
	\begin{itemize}
		\item Senders specify the required throughput in SYN and DATA segment.
		\item Routers along the path inspect the option header and allocate the feedback throughput.
		\item A router will set the feedback throughput only when the feedback throughput is smaller than the feedback throughput allocated by a previous router.
		\begin{itemize}
			\item It ensures that feedback throughput is calculated based on the most congested link along the path
		\end{itemize}
		\item Receiver copies the feedback throughput in the ACK segment.
		\item Sender sets the sending rate based on the ACK segment.
	\end{itemize}
\end{frame}

\section{Congestion Control}
\begin{frame}{Feedback Throughput Calculation}
	\begin{itemize}
		\item We have divided the feedback controller into two parts: 
		\begin{itemize}
			\item Delay Controller: \textit{Proportional Integral (PI)} controller
			\item Fairness Controller: Min-max fairness
		\end{itemize}
		\begin{block}{Delay Controller}
\begin{equation}\label{eq1} \sum r_i(t) = \alpha[c(t) - q(t)]\end{equation}

where the $\sum r_i(t)$ is the aggregate feedback throughput, $c(t)$ is the bottleneck link capacity, $q(t)$ is the queue length in bytes and $\alpha$ is the coefficient.
		\end{block}
		\begin{block}{Fairness Controller}
\begin{equation}r_i(t) = \frac{\alpha[c(t) - q(t)]}{N(t)}\end{equation} where $r_i(t)$ is the feedback throughput for flow $i$ and $N(t)$ is the number of flows
		\end{block}		

	\end{itemize}
\end{frame}
\subsection{Stability Analysis}
\begin{frame}{Stability Analysis}
	\begin{itemize}
		\item Let us assume that the feedback delay is $t_f$
		\item As the feedback rate becomes the sending rate after $t_f$,the sending rate at time $t$ can be written as
		\begin{equation}\label{eq5}x_i(t) = \frac{\alpha [C - q(t - t_f)]}{N}\end{equation}
		
		\item The queuing-delay gradient can be represented as \begin{equation}\label{eq3}
		\dot{q(t)} = \sum x_i(t) - C
		\end{equation}
		
		\item As flows adapt their sending rate $x_i(t)$ at the same rate, $\sum x_i(t) = N x_i(t)$ for all $i$.
		
		\item \begin{equation}\label{eq4}
		\dot{q(t)} = N x_i(t) - C
		\end{equation}
		
		\item \begin{equation}\label{eq4}
		 \dot{q(t)} = -\alpha q(t - t_f) + C(\alpha-1)
		\end{equation}
		
		
	\end{itemize}
\end{frame}
\begin{frame}{Stability Analysis}
	\begin{itemize}
		\item $\dot{q(t)} = -\alpha q(t - t_f) + C(\alpha-1)$ is an autonomous differential equation 
		
		\item The autonomous system is stable if $\ddot{q(t^*)} < 0$ where $q(t^*)$ represents the queuing delay at the equilibrium point
		
		\item This is why the system is stable if $\alpha > 0$.
		
		\item If the system is perturbed, the queue will be drained at $-\alpha q(t - t_f) + C(\alpha-1)$ rate and eventually reaches the equilibrium point
		
		\item At the equilibrium point, $\dot{q(t) = 0}$. So we get \begin{equation}\label{eq6}
		q(t - t_f) = \frac{C(\alpha-1)}{\alpha}
		\end{equation}
		
		\item $\frac{C(\alpha-1)}{\alpha}$ is the queuing delay at the equilibrium point.
		
		\item Here we want the queuing delay to be be zero while maximizing the throughput. That is why we set $\alpha = 1$.
	\end{itemize}		
\end{frame}
\subsection{Encoder Rate Control}
\begin{frame}{Encoder Rate Control}
	\begin{itemize}
		\item The encoding rate of video cannot be changed quickly in order to avoid congestion (takes more than \alert{500ms})
		
		\item The actual encoder output rate also fluctuates randomly around the input target rate.
		
		\item NC-TCP based application sets the target rate based on the feedback rate of the network. (Motivated from iTCP)
		
		\item As NC-TCP uses \alert{TCP-pacing}, packets wait in the TCP's sending buffer (congestion window) to be scheduled to sent out 		
		
		\begin{itemize}
			\item RTT produced by the NC-TCP is not exactly same as the propagation delay
			\item $RTT/RTT_{min}$ indicates how much encoder has overshot with respect to the network throughput. Here $RTT_{min}$ is the minimum RTT which is considered as the \textit{propagation delay}			
		\end{itemize}	
		
		\item We set the encoder target rate as $R_t(t) = \frac{r_i(t)}{\frac{RTT}{RTT_{min}}}$
		where $r_i(t)$ is the feedback throughput
		
	\end{itemize}		
\end{frame}	

\section{Implementation}
\begin{frame}{NC-TCP Implementation}
	\begin{itemize}
		\item We have implemented NC-TCP in Linux kernel. Source: \alert{https://github.com/tamimcse/Linux}
		\item NC-TCP implementation has two parts: NC-TCP host and NC-TCP router
		\item We have modified the Linux TCP stack to implement the NC-TCP host.	
		\item We have implemented the NC-TCP router as a Qdisc kernel module in \alert{Linux router (\textit{ip\_forward=1)}}.
		\item We also modified the kernel to trace system variables such as throughput, queue length, and so on.
	\end{itemize}
\end{frame}
\begin{frame}{Video Streaming Application}
	\begin{itemize}
		\item We also developed a TCP based video streaming application based on \alert{GStreamer}. 
		\item \alert{https://github.com/tamimcse/gst-streamer}  (350 lines of C code)

		\item The application reads a video file, encode in H.264 constant bit rate.

		\item The bitrate is set by the feedback rate received from the TCP stack. It uses It uses \alert{getsockopt} system call.
		
		\item The application stream the video frames to the client. Client displays the frames as soon as it receives it.
		
  
	\end{itemize}
\end{frame}

\section{Experimental Setup}
\begin{frame}{Experimental Setup}
\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{topology}
	\caption{Topology}\label{topology}
\end{figure}
	
	\begin{itemize}
		\item The topology is created in Mininet. 
		\item All the nodes in the picture is a Linux container (light-weight VM)
		\item All the links are virtual ethernet (veth) pair
		\item The delay and throughput on the links are set by \textbf{NetEm} and \textbf{htb} (hierarchical token bucket) Qdisc.
		\item The setup takes 200 lines of Python code. We also used Shell Scripts extensively. 
	\end{itemize}
	
\end{frame}
\begin{frame}{Experiment}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{topology}
		\caption{Topology}\label{topology}
	\end{figure}	
	\begin{itemize}
		\item We streamed a clip from \textbf{Big Buck Bunny}  in our experiment. 
		\item The sender produces \textit{512X340} video at 30 fps in H.264 format
		\item The three senders stream video simultaneously to the three receivers
		\item The experiment is conducted for 80 seconds.
		
	\end{itemize}
	
\end{frame}


\section{Evaluation}

\begin{frame}{Evaluation}
	\begin{itemize}
		\item Loss based TCP such as TCP CUBIC results in long queuing delay. 
		\item Recently proposed Google BBR also results in long queuing delay.
		\item We compared NC-TCP to \textbf{TCP Inigo} and \textbf{XCP}
		\item We found TCP Inigo is a representative of one-way delay gradient based TCP.
		\item The workflow of XCP is similar to NC-TCP. But it has been designed for short-lived flows.
		\item  We have found the implementation TCP CUBIC, TCP BBR and TCP CDG in Linux kernel.
		\item The Linux kernel implementation of TCP Inigo is also shared by it's author. We also have implemented the XCP in Linux kernel.
  
		\item We compared the \textbf{queuing delay}  on the bottleneck router for different protocols.
		
		\item We also have compared the \textbf{fairness} for each protocol. Note that higher fairness indicates that all the flows get higher throughput from the bottleneck link
	\end{itemize}
\end{frame}
\begin{frame}{NC-TCP vs XCP}
	\begin{itemize}
		\item \textbf{XCP} (eXplicit Congestion Control) is the first network-assisted congestion control algorithm where explicit rate is allocated by the router.
		\item XCP makes no assumption regarding the traffic characteristics whereas NC-TCP utilizes the traffic characteristics to optimize the throughput allocation.
		\item XCP uses window-based congestion control whereas NC-TCP uses rate based congestion control. 
		\item XCP uses persistent queue size, the minimum queue size during a control interval. NC-TCP however uses instant queue size. This enables NC-TCP to reacts to congestion quicker than XCP. 
		\item NC-TCP feedback throughput is calculated using $\frac{\alpha[c(t) - q(t)]}{N(t)}$ whereas XCP feedback is $\frac{\alpha RTT[c(t) - \sum x(t)] - \beta q(t)}{N(t)}$
		where $RTT$ is the average RTTs of all the flows and $\sum x(t)$ is the aggregate incoming-rate to the switch.
	\end{itemize}
\end{frame}
\subsection{Single-bottleneck Topology}
\begin{frame}{Bottleneck Queuing Delay}{Single-bottleneck Topology}
	\begin{itemize}
		\item The queuing delay is $\frac{q(t)}{B} $ where $B$ is the bottleneck throughput. 		
	\end{itemize}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{backlog}
		\caption{Queue Backlog}\label{backlog}
	\end{figure}			
\end{frame}

\begin{frame}{Throughput}{Single-bottleneck Topology}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{h1-throughput}
		\caption{Throughput}\label{backlog}
	\end{figure}			
\end{frame}

\begin{frame}{Fairness Index}{Single-bottleneck Topology}
	\begin{itemize}
		\item The fairness index has been calculated using the formula $\frac{{(\sum_{i=1}^{n} x_i)}^2}{n \sum_{i=1}^{n} {x_i}^2}$ where $x_i$ is the throughput of flow $i$ and $n$ is the total number of flows	
	\end{itemize}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{fairness}
		\caption{Jain's fairness index}\label{backlog}
	\end{figure}			
\end{frame}

\begin{frame}{Round-trip time}{Single-bottleneck Topology}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{h1-rtt}
		\caption{RTT}\label{RTT}
	\end{figure}			
\end{frame}

\subsection{Self-fairness}

\begin{frame}{Self-fairness}{Three TCP Inigo flows 15 seconds apart}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{flows-inigo}
		\caption{Three TCP Inigo flows 15 seconds apart}\label{flows-cdg}
	\end{figure}			
\end{frame}

\begin{frame}{Self-fairness}{Three NC-TCP flows 15 seconds apart}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{flows-im}
		\caption{Three NC-TCP flows 15 seconds apart}\label{flows-cdg}
	\end{figure}					
\end{frame}

\subsection{RTT-fairness}
\begin{frame}{RTT-fairness}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{topology}
		\caption{Topology}\label{topology}
	\end{figure}	
	\begin{itemize}
	\item We modified the topology such that each flow has different RTTs: \textbf{80ms}, \textbf{100ms} and \textbf{120ms} 		
	\end{itemize}
\end{frame}

\begin{frame}{Fairness Index}{RTT-fairness}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{rtt/fairness}
		\caption{Fairness Index}\label{topology}
	\end{figure}	
\end{frame}

\begin{frame}{Queuing delay}{RTT-fairness}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{rtt/backlog}
		\caption{Queuing delay in the bottleneck router}\label{backlog}
	\end{figure}	
\end{frame}

\subsection{Multiple bottlenecks topology }

\begin{frame}{Multiple bottlenecks topology}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{parkinglot}
		\caption{The throughput of bottleneck and access links are 660kbps and 1024kbps respectively}\label{topology}
	\end{figure}	
\end{frame}

\begin{frame}{Queuing delay}{Multiple bottlenecks topology}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{parkinglot/backlog}
	\end{figure}	
\end{frame}

\begin{frame}{Fairness Index}{Multiple bottlenecks topology}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{parkinglot/fairness}
	\end{figure}	
\end{frame}

\subsection{Differential Fairness}

\begin{frame}{Differential Fairness}
\begin{itemize}
	\item Interactive VDN needs to support heterogeneous endpoints such as smart phones, laptops, TV and VR headset at the same time
	\item The videos used in different endpoints often differ in encodings, resolutions and frame rates.
	\item Network-centric congestion control has a major advantage over host-centric approach in this regard
	\item As a router is aware of the throughput requirement of each flow passing through it, it can apply differential or weighted fairness in throughput allocation
\end{itemize}
\end{frame}

\subsection{Visual Interruptions}

\begin{frame}{Visual Interruptions}
	\begin {table}[H]
	\caption {Number of visual interruptions} \label{visual} 
	\begin{center}
		\begin{tabular}{ | m{5em} | m{3cm}| m{3cm} | } 
			\hline
			& Single bottleneck topology & Multiple bottleneck  topology\\ 
			\hline
			TCP Inigo & 2 & 20 \\ 
			\hline
			XCP & 0 & 0 \\ 
			\hline
			NC-TCP & 0 & 0 \\		
			\hline
		\end{tabular}
	\end{center}
	\end {table}
\end{frame}

\section{Data Plane Implementation}
\begin{frame}{Data Plane Implementation}
  \begin{itemize}
  \item Currently NC-TCP has been implemented in Linux Kernel to be executed on a CPU. 
  \item Implementation of NC-TCP on a programmable switch will be needed in order for real world deployment.
  
  \item Software Defined Network (SDN) enables to implement NC-TCP on the router
  
  \item The main idea behind SDN is programmable switching data-plane.

  \item Let's take a closer look into SDN!	

  \end{itemize}
\end{frame}

\subsection{Software Defined Network}

\begin{frame}{Software Router}
	\begin{itemize}
		\item CPU can forward packets at 40Gbps. 
		\item SDN router uses DPDK for packet processing and forwarding.
		
		\item DPDK stands for Data Plane Development Kit.
		
		\item DPDK is a technology that bypasses the kernel and enables to process packet in application layer.
		
		\item DPDK application can be programed using BPF framework.
		
		\begin{itemize}
			\item BPF stands for Binary packet Filter
			\item BPF program can be written in C or P4
		\end{itemize}
		
		\item Although software router provides 40Gbps throughput, it’s very small compared to hardware switch which provides several terabytes per second.	
		
	\end{itemize}
\end{frame}

\begin{frame}{Is Software Forwarding Scalable?}
	\begin{itemize}
		\item 100Gb NIC results in \textbf{8.4 Mpps} packets 
		\begin{itemize}
			\item $100*10^9/(8*1500)$
		\end{itemize}		
		\item \textbf{119ns} per packet
		\item \alert{238 cpu cycles} for a 2GHz Xeon core
		
		\item But packet forwarding is IO intensive, not CPU intensive. For example, IPv4 forwarding requires at least 2 memory access.
		
		\item Memory access requires \alert{120-140 cpu cycles}
		
		\item This problem gets much worse for smaller packets. 
		
		\item Software Router cannot match the speed of hardware (40Gb/s vs several Tb/s). Solution?
		\begin{itemize}
			\item \alert{Software Processing}
		\end{itemize}				
		
	\end{itemize}
\end{frame}

\begin{frame}{Software Packet processing}
	\begin{itemize}
		\item Do the packet forwarding in hardware. CPU cannot simply beat it.
		\item Do the packet processing such as header manipulation on CPU.
		\item This is why we need a programmable switch that has both a \textbf{switch fabric} and \textbf{CPU}.
		\begin{itemize}
			\item The switch fabric is responsible for packet forwarding
			\item CPU is responsible for packet processing.
		\end{itemize}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{sdn}
	\end{figure}	
		
	\end{itemize}
\end{frame}

\begin{frame}{Programmable Switch}
		\begin{figure}[!t]
			\centering
			\includegraphics[width=9cm]{sdn}
		\end{figure}
	\begin{itemize}
		\item Forwarding is done by a TCAM. TCAM offers O(1) lookup time. 
		\item Switch is responsible for transferring packets among the ports (instead of shared bus).
		\item Each port has its own FIB, FDB, ACL and so on.
	\end{itemize}
\end{frame}

\begin{frame}{Programmable Switch}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{linecard}
	\end{figure}
	\begin{itemize}
		\item Each port has a CPU that supports limited BPF instruction-set.
		\item The BPF CPU is exposed to control plane CPU via memory mapped IO (MMIO). Control plane CPU can load a BPF program on to the BPF CPU.
	\end{itemize}
\end{frame}

\begin{frame}{Data-plane Programming}
	\begin{itemize}
		\item The programming environment depends on switch manufacturer. Switch manufacturer provides a proprietary SDK that provides very limited programming capability to others.		 
		\item Recently \textbf{P4} and \textbf{BPF} programming framework have been developed that provides a standardized way to program the data-plane.
		\item NC-TCP data-plane needs to modify packets based on queue length and number of flows. P4 does not have those information.
		\item eBPF (extened Binary packet Filter) is a framework where queue length and number of flows are accessible through meta-data.  
		\item This is why we are planning to use \textbf{eBPF} to program NC-TCP router.
		\item Currently there is no eBPF supported hardware switch to the best of our knowledge. It's mostly used in virtual switches. 
	\end{itemize}
\end{frame}


\begin{frame}{SDN Vendors}
		\begin{block}{CPU and NIC Vendor}
			Intel, Mellanox, Brodcom, Cavium, Barefoot, Marvell, Nokia, Freescale, Netronome, Texas Instrument, Qualcomm
		\end{block}
		\begin{block}{Appliance Vendor}
			\begin{itemize}
			\item Cisco, Juniper, Brocade, Arista, Huawei, Cumulus, 6Wind, Wind River, Enea, Timesys, NoviFlow, Ericsson, NEC, Checkpoint, Qosmos
			\item Cloud providers also developing their own appliance. This include RedHat, Parallels, Noira, Intel, Facebook, VMWare, Google, IBM, ARM, SUSE, Exoscale, Canonical, Sophos, Covalent, CloudFare, Solarflare, Suricata etc
			\item Small ISPs such as Xmission, Cambridge Brodband, Mojatutu are also developing their own appliance based on Linux.
			\end{itemize}
		\end{block}
	\begin{itemize}
		\item \alert{The switch manufactures provides a proprietary SDK to utilize the switch. But closed source nature of SDK refrains appliance vendor and individual developers to program the switch.} 
	\end{itemize}
\end{frame}

\begin{frame}{Open Source SDN}
	\begin{itemize}
		\item Recently people from Mellanox and Intel came forward to solve this problem.
		\item A switch driver model \textbf{switchdev} has been proposed to replace the \textbf{proprietary SDK}.
		\item Mellanox have few hardware switches based on switchdev. However \alert{currently they do not support eBPF program}
		\item Mellanox however expressed interest to support eBPF offloading in the future. 
		\item This is why we are planning to develop eBPF program with Linux router. 
		\item Once the hardware-router adds eBPF offloading, the same program can be offloaded to the hardware-router.
	\end{itemize}
\end{frame}

\begin{frame}{Inside Linux Router}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{switchdev}
	\end{figure}
	\begin{itemize}
	\item Currently there is no hardware switch available that can offload eBPF program
	\end{itemize}	
\end{frame}

\begin{frame}{Linux Router Without Switch Hardware}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{switchdevveth}
	\end{figure}
	\begin{itemize}
		\item Hardware switch is replaced by Veth (Virtual Ethernet) kernel module.  
		\item Packet is forwarded by Route and Bridge. eBPF program on each veth is executed on each packet.		
	\end{itemize}	
\end{frame}

\begin{frame}{Packet Processing at Line-rate}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{sdn}
	\end{figure}	
	\begin{itemize}
		\item It has shown that a programmable switch can forward packets at line-rate if each port can process packets at line-rate
		\item Most of the switches come with 10Gb/s and 40Gb/s port
		\item This is why eBPF program needs to process packets at 40Gb/s.

	\end{itemize}
\end{frame}

\begin{frame}{Line-rate NC-TCP}
	\begin{figure}[!t]
		\centering
		\includegraphics[width=9cm]{linerate}
	\end{figure}	
	\begin{itemize}
		\item We are planning to develop a eBPF program to implement NC-TCP.
		\item Traffic will be generated by \textit{iperf}.
		\item \textit{iperf} will also be used to calculate the throughput
		\item We will measure how much throughput eBPF NC-TCP program can achieve through in the topology.
		\item We expect to achieve at-least 40Gb/s throughput here. In reality, we hope to see much more.
		\item This will indicate that a CPU is able to process NC-TCP router at line-rate. 
		\item We will also analyze the eBPF Instruction set. 
		\item The instruction-set enable us to calculate how much CPU clock-rate is needed for line-rate line-rate NC-TCP processing.
	\end{itemize}
\end{frame}

\begin{frame}{Feedback (Dr. Peyravi)}	
	\begin{itemize}
		\item How is dealing when routes are changing frequently? It does not. We have no way of knowing what will happend if route changes frequently. Best option is to use a routing algorithm that does not change very frequently.
		\item If there a tandem queue (multiple bottleneck), some queue will be empty. How to handle the situation? Solution is to track the incoming traffic rate. If $C-\sum X_i(t) > 0$ then $r_i(t) = \frac{\alpha[c(t) - q(t)] + [C-\sum X_i(t)]}{N(t)}$. XCP uses this solution. But better solution is to increase $\alpha$ to increase utilization if queue becomes empty. Note that this won't affect stability of the system. Because next router does not necessarily allow the throughput if it does not able to handle that. If following routers are able to handle the rate only then the increase of $\alpha$ helps. 
		\item How to ensure if utilization is not 100\%?		
		\item How to ensure local dicision by each router leads to global fairness?
	\end{itemize}
\end{frame}

\begin{frame}{Feedback (Dr. Peyravi)}	
	\begin{itemize}
		\item How it is handling CSMACD in layer-2? It doesn\'t. We need a dedicated Video Delivery Network for this. Differentiated service or Network virtualization can possibly provide this service. It's upto the Network Virtualization or DiffServ provider to guarantee the rate. They usually work in Layer-3. So they generally cannot guarntee layer-2. 
		\item 0\% packet-loss is not practical? It is actually. Last few decades Memory have became very cheap and NIC has become very fast. This is why routers can cache packet. For example, Google has moved away from loss-based congestion control to BBR. Packet-loss also can be ignored interactive video streaming. 	
		\item What happens if there is flow in opposite direction? Actually there is no sense of direction to router. Router treats each direction of a flow as one flow. So if there is a reverse path traffic, router would consider two flows here instead of one.
	\end{itemize}
\end{frame}

\begin{frame}{Feedback}	
	\begin{itemize}	
		\item How is it better stable than XCP? I guess, the question is how is it more smooth than XCP? Show mathematicaly.
		\item Will it work for multi-path TCP? It does because feedback for both route is calculated independently.		
		\item Will the long feedback delay be problem in stability?
		\item Can we change between TCP window and TCP Pacing? 
		\item Can we increase or decrease the value of $\alpha$ to make it drain quickly?
		\item what does first order and second order differentiation of q(t) means? 
		\item Can it fall back the traditional TCP? Is the incremental deployment possible?
		\item Is this scalable in terms of big network? Can you prove if local stability results in global stability? 
		\item Will the system be stable if feedback delay is very high? Not applicable for Video network..
	\end{itemize}
\end{frame}

\begin{frame}{}
	\centering \Large
	\Huge{Thank You}
\end{frame}

\end{document}


